module Table where

data Table a = Table (String -> a)
instance Show (Table a) where
    show x = "Table"

---initialTable errorMessage = Table (\x -> error (errorMessage ++ show x))
initialTable defaultValue = Table defaultValue
updateTable (Table table) name value = Table (\x -> if x == name then value else table x)
contentTable (Table table) name = table name
offsetTable t name = snd $ contentTable t name
